#include "AneuMeshLoader.h"
#include <fstream>
#include "Exceptions.h"

void AneuMeshLoader::loadMesh(const std::string& str) {
	std::ifstream file(str);

	if (!file) {
		throw FileIsNotFound(str);
	}

	int n, k, c;
	double c2;
	file >> n >> k;
	for (int i = 1; i <= n; i++) {
		Node a;
		a.ID_Node = i;
		for (int j = 1; j <= k; j++) {
			file >> c2;
			a.Coordinate.push_back(c2);
		}
		a.flag = true;
        // ПРИ ВЫЗОВЕ push_back БУДУТ ВОЗНИКАТЬ СИТУАЦИИ, КОГДА
        // МЕСТА ДЛЯ НОВОГО ЭЛЕМЕНТА НЕТ, ПОЭТОМУ БУДЕТ ВЫДЕЛЕН
        // НОВЫЙ КУСОК ПАМЯТИ БОЛЬШЕГО РАЗМЕРА (В ДВА РАЗА), ПОСЛЕ ЭТОГО
        // БУДЕТ КОПИРОВАНИЕ ИЗ СТАРОЙ ОБЛАСТИ ПАМЯТИ В НОВУЮ
        // В ЗАВИСИМОСТИ ОТ КОЛИЧЕСТВА УЗЛОВ В ФАЙЛЕ, ТАКАЯ СИТУАЦИЯ
        // МОЖЕТ ВОЗНИКАТЬ МНОГОКРАТНО
        // РЕШЕНИЕ: РАЗМЕР ВЕКТОРА ИЗВЕСТЕН ДО ЦИКЛА, ПОЭТОМУ СТОИТ
        // ЗАРЕЗЕРВИРОВАТЬ НУЖНОЕ КОЛИЧЕСТВО ЭЛЕМЕНТОВ
        // http://www.cplusplus.com/reference/vector/vector/reserve/
        node.push_back(std::move(a));
	}

	file >> n >> k;
	for (int i = 1; i <= n; i++) {
		FiniteElement a;
		a.ID_FiniteElement = i;
		file >> a.ID_Material;
		for (int j = 1; j <= k; j++) {
			file >> c;
			a.ID_Nodes.push_back(c);
		}
        // ТО ЖЕ САМОЕ
		finite_el.push_back(std::move(a));
	}

	file >> n >> k;
	for (int i = 1; i <= n; i++) {
		BoundaryFiniteElement a;
		a.ID_Element = i;
		file >> a.ID_Boundary;
		for (int j = 1; j <= k; j++) {
			file >> c;
			a.ID_Nodes.push_back(c);
		}
        // ТО ЖЕ САМОЕ
        boundary_el.push_back(std::move(a));
	}
	file.close();
}
