#pragma once
#include "DataType.h"

class MeshLoader {
protected:
	std::vector<Node> node;
	std::vector<FiniteElement> finite_el;
	std::vector<BoundaryFiniteElement> boundary_el;

public:
	virtual void loadMesh(const std::string&) = 0;
	virtual ~MeshLoader() = default;
	std::vector<Node>& GetNode();
	std::vector<FiniteElement>& GetFiniteElement();
	std::vector<BoundaryFiniteElement>& GetBoundaryElement();
	std::vector<int> ElementByThreeNodes(int, int, int);
	std::vector<int> ElementByTwoNodes(int id1, int id2);
	std::set<int> BoundaryNodesByID(int);
	std::set<int> FiniteElementsByArea(int id);
	std::vector<int> BoundaryElementsByID(int id);
	void insert_middle();
	std::vector<std::set<int>> Neighbor_Nodes();
	void print_DataTypes();
};

