#include "AneuMeshLoader.h"
#include <fstream>
#include <cmath>
#include <iterator>


int main() {
    // unique_ptr ЗДЕСЬ БОЛЬШЕ ПОДХОДИТ, ВЕДЬ РАЗДЕЛЬНОЕ ВЛАДЕНИЕ НЕ ТРЕБУЕТСЯ
	std::shared_ptr<MeshLoader> p(new AneuMeshLoader);
	std::string str;
	std::cout << "Enter the file name: ";
	std::cin >> str;
	p->loadMesh(str);
	std::cout << "---------------STL-container Nodes---------------" << std::endl;
	std::cout << p->GetNode() << std::endl;
	std::cout << "---------------STL-container Finite Elements---------------" << std::endl;
	std::cout << p->GetFiniteElement() << std::endl;
	std::cout << "---------------STL-container Boundary Finite Elements---------------" << std::endl;
	std::cout << p->GetBoundaryElement() << std::endl;
	std::cout << "---------------Finite Element by three nodes---------------" << std::endl;
	std::cout << "Enter three nodes: ";
	int id1, id2, id3;
	std::cin >> id1 >> id2 >> id3;
	std::cout << p->ElementByThreeNodes(id1, id2, id3) << std::endl;
	std::cout << "---------------Finite Element by two nodes---------------" << std::endl;
	std::cout << "Enter two nodes: ";
	std::cin >> id1 >> id2;
	std::cout << p->ElementByTwoNodes(id1, id2) << std::endl;
	std::cout << "---------------Container of Boundary Nodes by boundary ID---------------" << std::endl;
	std::cout << "Enter border ID: ";
	std::cin >> id1;
	std::cout << p->BoundaryNodesByID(id1) << std::endl;
	std::cout << "---------------Container Finite Element by boundery ID---------------" << std::endl;
	std::cout << "Enter border ID: ";
	std::cin >> id1;
	std::cout << p->FiniteElementsByArea(id1) << std::endl;
	std::cout << "---------------Container boundary Finite Elements by boundary ID---------------" << std::endl;
	std::cout << "Enter border ID: ";
	std::cin >> id1;
	std::cout << p->BoundaryElementsByID(id1) << std::endl;
	std::cout << "---------------Container with containers of neighboring nodes---------------" << std::endl;
	std::cout << p->Neighbor_Nodes() << std::endl;
	std::cout << "---------------Print Node, Finite Element, Boundary Element---------------" << std::endl;
	p->print_DataTypes();
	std::cout << "---------------Inserting new nodes in the middle of the edges of the Finite Elements---------------" << std::endl;
	p->insert_middle();
	std::cout << "STL-container Nodes:" << std::endl;
	std::cout << p->GetNode() << std::endl;
	std::cout << "STL-container Finite Elements:" << std::endl;
	std::cout << p->GetFiniteElement() << std::endl;
	std::cout << "STL-container Boundary Finite Elements:" << std::endl;
	std::cout << p->GetBoundaryElement() << std::endl;

	return 0;
}
